//---------------------------------------------------------------------------
//	Takahiro Hayashi 2001.06.27
//	hayasita@na.rim.or.jp
//---------------------------------------------------------------------------

#include "shiori_dll.h"
#include "nasino.h"
#include "nasino_script.h"
#include "nasino_sccomm.h"

#define	STKSIZE		5000					// ԃR[hspX^bNTCY
#define	CODESIZE	5000
#define LBLSIZE		500

extern char LogTmp[AnswerLength];
extern char DataPath[PathLength];						/* ghostpath */
extern int Script_Log;

extern FILE* yyin;
struct tree codetree;					// \؍쐬p[N
int label_count = 0;
int label_table[LBLSIZE] = {0};

//struct code *code_memory;
int code_count = 0;						// ԃR[hC
int CodeMaxLine = CODESIZE;				// ԃR[hi[z̐@ŒŎ̂ł͂ȂAPpXڂŕKvȗ̈𒲍B
struct code code_memory[CODESIZE];

int stack[STKSIZE] = {0};				// ԃR[hspGA
int stack_datatype[STKSIZE] = {0};

c22event sakura_event;					// SHIORI/2.2̓Cxg
c22event user_event;					// ScriptŔ User Event
symbol script_symbols;					// ϐi[̈
//stringobj strobj;						// i[̈
int talk_interval_val;


//---------------------------------------------------------------------------
//		V{̖O̒`
//---------------------------------------------------------------------------
char *sakura_eventsymbol[] = {
	"event",
	"reference0",
	"reference1",
	"reference2",
	"reference3",
	"reference4",
	"reference5",
	"reference6",
	"reference7"
};
char *user_eventsymbol[] = {
	"user_event",
	"user_reference0",
	"user_reference1",
	"user_reference2",
	"user_reference3",
	"user_reference4",
	"user_reference5",
	"user_reference6",
	"user_reference7"
};

char symbolname_talk_interval[] = "talk_interval";


//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
int nasino_script_init(char* script_name)
{
	FILE* fp;
	int count1;
	char filename[DataLength];
	
	script_logwrite("nasino_script_init\n");
	logwrite("nasino_script_init\n");
	
	sprintf(filename,"%s%s",DataPath,script_name);
//	sprintf(filename,"%sscript.nc",DataPath);
	printf("filename : %s\n",filename);
	fp = fopen(filename,"rt");
	if (!fp){
		sprintf(LogTmp,"%sǂݍނƂł܂\n",filename);
		script_logwrite(LogTmp);
		return(NG);
	}
	yyin = fp;  // yyparse ̓͂t@Cɂ
	
	// R[hGÅm
//	if((code_memory = (struct code*)malloc(sizeof(struct code) * CodeMaxLine)) == NULL){
//		// error
//		printf("R[hGÅmۂł܂\n");
//		script_logwrite("R[hGÅmۂł܂\n");
//		return(NG);
//	}
	
	Reserve_Num = SYSTEM_RESERVE;					// VXe\ϐ̗̈`
	Code_Num = NASINO_CODE_NUM;						// ϐ̗̈`
	
	codetree.init(1000);								// \؂̍쐬p[N̗̈m
	script_symbols.init();							// ϐ̗̈m
//	script_symbols.init(Code_Num);					// ϐ̗̈m
//	strobj.init();									// ̗̈mہ@R[h
//	strobj.init(1000);								// ̗̈mہ@R[h
	
	// ԃR[h̍쐬
	yyparse();							// R[h̃p[X
	nasino_script_labelcomp();			// x̍쐬
	nasino_script_dumpcode();			// ԃR[h̕\
	fclose(fp);
	
	return(OK);
}

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
int nasino_script_main(struct s20_data *inputevent)
{
	int userevent_code;
	int count1;
	int ret;
	
	if(strlen(inputevent->event) != 0){
		// eventƂXNvgB
		sakura_event.init();
		user_event.init();						// [U[Cxg
		sakura_event.set_event(inputevent);		// Cxgscript̑gϐփRs[
	
		if(Script_Log == ON){
			printf("SAKURA EVENT INPUT\n");
			script_logwrite("SAKURA EVENT\n");
			for(count1=S22EVENT_EVENT;count1<=S22EVENT_REFERENCE7;count1++){
				printf("input:%s:\n",sakura_event.get_str(count1));
				sprintf(LogTmp,"input:%s:\n",sakura_event.get_str(count1));
				script_logwrite(LogTmp);
			}
			script_logwrite("\n");
		}
		
		nasino_script_execute();			// R[h̎s
	
		script_datadump();
		
		if(Script_Log == ON){
			sprintf(LogTmp,"Script event(input):%s:\n",inputevent->event);
			logwrite(LogTmp);
			sprintf(LogTmp,"Script event(user):%s:\n",user_event.get_str(S22EVENT_EVENT));
			logwrite(LogTmp);
		}
		
		user_event.get_event(inputevent);
		
		if(Script_Log == ON){
			sprintf(LogTmp,"Script event(output):%s:\n",inputevent->event);
			logwrite(LogTmp);
			script_logwrite("\n");
			script_logwrite("-----------------------------------------\n");
		}
	
		sakura_event.clear();
		user_event.clear();					// [U[Cxg̈

	}
	
	return(ret);
}

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
void nasino_script_unload()
{
	int count1;

//	for(count1=0;count1<symbol_count;count1++){
//		free(symbols[count1].name);
//	}
	
	printf("nasino_script_unload\n");

	codetree.clear();
	script_symbols.clear();			// ϐ̗̈J
//	strobj.clear();					// ̗̈J

	return;
}

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
void nasino_script_codegenerator(int opecode,int subcode)
{
	int opecode_tmp;
	int subcode_tmp;

//	printf("nasino_script_codegenerator\n");
	if(code_count >= CodeMaxLine){
		// G[
		// sstO̐ƃG[\s
	}else{
//		printf("codegenerator:%d:%d\n",opecode,subcode);
		if(opecode == OP_CAL){
			switch(subcode){
				case ADD:
					opecode_tmp = OP_ADD;
					break;
				case SUB:
					opecode_tmp = OP_SUB;
					break;
				case MUL:
					opecode_tmp = OP_MUL;
					break;
				case DIV:
					opecode_tmp = OP_DIV;
					break;
				case MIN:
					opecode_tmp = OP_MIN;
					break;
				case EQ:
					opecode_tmp = OP_EQ;
					break;
				case NT:
					opecode_tmp = OP_NEQ;
					break;
				case GT:
					opecode_tmp = OP_GT;
					break;
				case GE:
					opecode_tmp = OP_GE;
					break;
				case LS:
					opecode_tmp = OP_LS;
					break;
				case LE:
					opecode_tmp = OP_LE;
					break;
				case AND:
					opecode_tmp = OP_AND;
					break;
				case OR:
					opecode_tmp = OP_OR;
					break;
					
			}
			subcode_tmp = subcode;			// _~[
		}else{
			opecode_tmp = opecode;
			subcode_tmp = subcode;
		}
		code_memory[code_count].opecode = opecode_tmp;
		code_memory[code_count].subcode = subcode_tmp;
		printf("codegenerator[%3d]:%3d:%3d\n",code_count,code_memory[code_count].opecode,code_memory[code_count].subcode);
		code_count++;
	}

	return;
}

//---------------------------------------------------------------------------
//	s
//---------------------------------------------------------------------------
int nasino_script_execute(void)
{
	int num;													//
	int sub;
	int ret;
	
	int temp1;
	int temp2;
	char temp_c1[2048];
	char temp_c2[2048];
	
	int error;
	
	int sp = -1;
	int pc = 0;								// vOJE^

	while (pc < code_count) {
		if(sp >= 0){
			printf("PC:%d : SP:%d : %d\n",pc,sp,stack[sp]);
			sprintf(LogTmp,"PC:%3d : SP:%3d : %3d\n",pc,sp,stack[sp]);
		}else{
			printf("PC:%d : SP:%d : \n",pc,sp);
			sprintf(LogTmp,"PC:%3d : SP:%3d : \n",pc,sp);
		}
//		script_logwrite(LogTmp);

		sub = code_memory[pc].subcode;
		switch(code_memory[pc].opecode) {
			case OP_POP:
				temp1 = nasino_script_getstackval(sp--);
//				printf("OP_POP:TYPE_NUM:%d:%d\n",stack[sp+1],temp1);
				put_symbol_value(sub,temp1);					// l
				break;
			case OP_PSHI:
				if (++sp >= STKSIZE){
					script_logwrite("nasino script exec stack overflow!!!\n");
				}
				nasino_script_setstackval(sp,sub,script_symbols.get_symbol_type(sub));
///				stack[sp] = symbols[sub].value;
//				printf("OP_PSHI:%d\n",sub);
//				stack[sp] = sub;					//
//				stack_datatype[sp] = script_symbols.get_symbol_type(sub);
				break;
			case OP_PSHN:
				if (++sp >= STKSIZE){
					script_logwrite("nasino script exec stack overflow!!!\n");
				}
				nasino_script_setstackval(sp,sub,TYPE_NUM);
				break;
			case OP_PSHP:
				if (++sp >= STKSIZE){
					script_logwrite("nasino script exec stack overflow!!!\n");
				}
				nasino_script_setstackval(sp,sub,TYPE_CHAR);
//				stack[sp] = sub;
//				stack_datatype[sp] = TYPE_CHAR;
				break;

			case OP_ADD:
				error = nasino_sccom_add(&sp);
//				--sp;
//				temp1 = nasino_script_getstackval(sp);
//				temp2 = nasino_script_getstackval(sp + 1);
//				nasino_script_setstackval(sp,(temp1 + temp2),TYPE_NUM);
				break;
			case OP_SUB:
				--sp;
				temp1 = nasino_script_getstackval(sp);
				temp2 = nasino_script_getstackval(sp + 1);
				nasino_script_setstackval(sp,(temp1 - temp2),TYPE_NUM);
				break;
			case OP_MIN:
				temp1 = nasino_script_getstackval(sp);
				nasino_script_setstackval(sp,(- temp1),TYPE_NUM);
				break;
			case OP_MUL:
				--sp;
				temp1 = nasino_script_getstackval(sp);
				temp2 = nasino_script_getstackval(sp + 1);
				nasino_script_setstackval(sp,(temp1 * temp2),TYPE_NUM);
				break;
			case OP_DIV:
				--sp;
				temp1 = nasino_script_getstackval(sp);
				temp2 = nasino_script_getstackval(sp + 1);
				nasino_script_setstackval(sp,(temp1 / temp2),TYPE_NUM);
				break;
			case OP_EQ:
				--sp;
				temp1 = nasino_script_getstackval(sp);
				temp2 = nasino_script_getstackval(sp + 1);
				nasino_script_setstackval(sp,(temp1 == temp2),TYPE_NUM);
//				printf("OP_EQ:%d:%d\n",temp1,temp2);
				break;
			case OP_GT:
				--sp;
				temp1 = nasino_script_getstackval(sp);
				temp2 = nasino_script_getstackval(sp + 1);
				nasino_script_setstackval(sp,(temp1 > temp2),TYPE_NUM);
//				stack[sp] = (temp1 > temp2);
//				stack_datatype[sp] = TYPE_NUM;
///				stack[sp] = (stack[sp] > stack[sp + 1]);
				break;
			case OP_GE:
				--sp;
				temp1 = nasino_script_getstackval(sp);
				temp2 = nasino_script_getstackval(sp + 1);
				nasino_script_setstackval(sp,(temp1 >= temp2),TYPE_NUM);
//				stack[sp] = (temp1 >= temp2);
//				stack_datatype[sp] = TYPE_NUM;
///				stack[sp] = (stack[sp] >= stack[sp + 1]);
				break;

			case OP_LS:
				--sp;
				temp1 = nasino_script_getstackval(sp);
				temp2 = nasino_script_getstackval(sp + 1);
				nasino_script_setstackval(sp,(temp1 < temp2),TYPE_NUM);
//				stack[sp] = (temp1 < temp2);
//				stack_datatype[sp] = TYPE_NUM;
///				stack[sp] = (stack[sp] < stack[sp + 1]);
				break;
			case OP_LE:
				--sp;
				temp1 = nasino_script_getstackval(sp);
				temp2 = nasino_script_getstackval(sp + 1);
				nasino_script_setstackval(sp,(temp1 <= temp2),TYPE_NUM);
//				stack[sp] = (temp1 <= temp2);
//				stack_datatype[sp] = TYPE_NUM;
///				stack[sp] = (stack[sp] <= stack[sp + 1]);
//				sprintf(LogTmp,"OP_LE:%d:%d:%d\n",temp1,temp2,stack[sp]);
//				script_logwrite(LogTmp);
				break;
			case OP_NEQ:
				--sp;
				temp1 = nasino_script_getstackval(sp);
				temp2 = nasino_script_getstackval(sp + 1);
				nasino_script_setstackval(sp,(temp1 != temp2),TYPE_NUM);
//				stack[sp] = (temp1 != temp2);
//				stack_datatype[sp] = TYPE_NUM;
///				stack[sp] = (stack[sp] != stack[sp + 1]);
				break;
				
			case OP_JP:
				pc = sub;
				break;
			case OP_JPZ:
				if (stack[sp--] == 0)
					pc = sub;
				break;
				
			case OP_STRCPY:					// strcpy(string2,string1);
				temp1 = stack[sp--];
				temp2 = stack[sp--];
//				printf("OP_STRCPY:%d:%d:\n",temp1,temp2);
				nasino_script_getstring(temp_c1,temp1);
//				printf("OP_STRCPY:%s\n",temp_c1);
				if(temp2 < Reserve_Num){
					if(temp2<=SHIORI_REFERENCE7){
						sakura_event.set_str(temp2-SHIORI_EVENT,temp_c1);
					}else if(temp2<=USER_REFERENCE7){
//						printf("user_event\n");
						user_event.set_str(temp2-USER_EVENT,temp_c1);
					}
				}else if(temp2 < (Reserve_Num + Code_Num)){
					script_symbols.set_symbol_str(temp2,temp_c1);
				}else{
					printf("PC %4d : OP_STRCPY:Rs[悪|C^łȂB\n",pc,temp1,temp2);
					sprintf(LogTmp,"PC %4d : OP_STRCPY:Rs[悪|C^łȂB\n",pc,temp1,temp2);
				}
				break;
			case OP_STRCAT:					// strcat(string2,string1);
				error = nasino_sccom_strcat(&sp);
				break;
			case OP_STRCMP:					// strcmp(string2,string1);
				temp1 = stack[sp--];
				temp2 = stack[sp];
//				printf("OP_STRCMP:%d:%d:\n",temp1,temp2);
//				printf("%s\n",temp_c1);
				nasino_script_getstring(temp_c1,temp1);
				nasino_script_getstring(temp_c2,temp2);
//				printf("OP_STRCMP:%s:%s\n",temp_c1,temp_c2);
//				sprintf(LogTmp,"OP_STRCMP:%s:%s\n",temp_c1,temp_c2);
//				script_logwrite(LogTmp);
				stack[sp] = strcmp(temp_c2,temp_c1);
				stack_datatype[sp] = TYPE_NUM;
				break;
			case OP_ATOI:				// atoi(number);
				temp1 = stack[sp];
				nasino_script_getstring(temp_c1,temp1);
//				printf("OP_ATOI:%d:%s\n",temp1,temp_c1);
//				sprintf(LogTmp,"OP_ATOI:%d:%s\n",temp1,temp_c1);
				stack[sp] = atoi(temp_c1);
				stack_datatype[sp] = TYPE_NUM;
				break;
			case OP_ITOA:				// itoa(string);
				error = nasino_sccom_itoa(&sp);
				break;
			case OP_DATE:				// date(string);
				error = nasino_sccom_date(&sp);
				break;
			case OP_SSTPSEND:			// sstpsend(string,string,string);
				error = nasino_sccom_sstpsend(&sp);
				break;
			case OP_SAVE:				// save(string);
				error = nasino_sccom_save(&sp);
				break;
			case OP_LOAD:				// load(string);
				error = nasino_sccom_load(&sp);
				break;
			case OP_GET_INITFILEDATA:	// get_initfiledata(string);
				error = nasino_sccom_get_initfiledata(&sp);
				break;
				
		}
//		script_logwrite(LogTmp);
		++pc;
	}
	
	return(ret);
}

//---------------------------------------------------------------------------
//		sX^bN̕ϐEString̓e̎o
//---------------------------------------------------------------------------
char *nasino_script_getstackstring(int sp)
{
	char *ret;
	int num;
	
	num = stack[sp];
	
	if(num < Reserve_Num){								// VXeϐ
		if(num<=SHIORI_REFERENCE7){								// system event,system reference
			ret = sakura_event.get_str(num-SHIORI_EVENT);
		}else if(num<=USER_REFERENCE7){							// user event,user reference
			ret = user_event.get_str(num-USER_EVENT);
		}else if(num == TALK_INTERVAL){							// talk_interval
//			ret = talk_interval_val;
		}
	}else{												// [U[`ϐ
		if(script_symbols.get_symbol_type(num) != TYPE_STR){
			ret = script_symbols.get_symbol_str(num);			// ϐo
		}else{
			ret = script_symbols.pop_string(num);				// Stringo
		}
	}
	
//	printf("%s\n",ret);
	
	return(ret);
}
//---------------------------------------------------------------------------
//		ϐEString̓e̎o
//---------------------------------------------------------------------------
int nasino_script_getstring(char *word,int num)
{
	int ret;

	if(num < Reserve_Num){								// VXeϐ
		if(num<=SHIORI_REFERENCE7){								// system event,system reference
			strcpy(word,sakura_event.get_str(num-SHIORI_EVENT));
//			printf("sakura:%s\n",word);
//			sprintf(LogTmp,"sakura:%s\n",word);
//			script_logwrite(LogTmp);
		}else if(num<=USER_REFERENCE7){							// user event,user reference
			strcpy(word,user_event.get_str(num-USER_EVENT));
		}
	}else{												// [U[`ϐ
		if(script_symbols.get_symbol_type(num) != TYPE_STR){
			strcpy(word,script_symbols.get_symbol_str(num));	// ϐo
//			printf("sakura Code_Num:%s\n",word);
		}else{
			strcpy(word,script_symbols.pop_string(num));		// Stringo
//			strcpy(word,strobj.pop_string(num));
//			printf("sakura etc:%s\n",word);
		}
	}
/*
	}else if(num < (Reserve_Num + Code_Num)){
		strcpy(word,script_symbols.get_symbol_str(num));
//		printf("sakura Code_Num:%s\n",word);
	}else{
		strcpy(word,script_symbols.pop_string(num));
//		strcpy(word,strobj.pop_string(num));
//		printf("sakura etc:%s\n",word);
	}
*/
	return(ret);
}

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
char *get_symbol_name(int num)
{
	char *name;
	
	if(num < Reserve_Num){								// VXeϐ
		if((num >= SHIORI_EVENT) && (num <= SHIORI_REFERENCE7)){	// event,reference0`7
			name = sakura_eventsymbol[num - SHIORI_EVENT];
		}else if((num >= USER_EVENT) &&(num <= USER_REFERENCE7)){	// user_event,user_reference0`7
			name = user_eventsymbol[num - USER_EVENT];
		}else if(num == TALK_INTERVAL){							// talk_interval
			name = symbolname_talk_interval;
		}
	}else{												// [U[`ϐ
		name = script_symbols.get_symbol_name(num);
	}
	
	return(name);
}


//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
int put_symbol_value(int num,int value)
{
	int ret;

	if(num < Reserve_Num){
		if((num >= SHIORI_EVENT) &&(num <= SHIORI_REFERENCE7)){		// event,reference0`7
//			printf("put_symbol_val:%d:%d\n",num,value);
			sakura_event.put(num - SHIORI_EVENT,value);
//			printf("put_symbol_val:%d:%d\n",num,sakura_event.get(num - SHIORI_EVENT));
			ret = OK;
		}else if((num >= USER_EVENT) &&(num <= USER_REFERENCE7)){	// user_event,user_reference0`7
			user_event.put(num - USER_EVENT,value);
			ret = OK;
		}else if(num == TALK_INTERVAL){								// talk_interval
			talk_interval_val = value;
			ret = OK;
		}else{
			ret = NG;
		}
	}else{
//		printf("num:%d :val:%d\n",num,value);
		ret = script_symbols.set_symbol_val(num,value);
	}
	
	return(ret);
}

//---------------------------------------------------------------------------
//		sX^bN̕ϐEl̓e̎o
//---------------------------------------------------------------------------
int nasino_script_getstackval(int sp)
{
	int ret;
	
	
//	if(stack[sp] == TALK_INTERVAL){							// talk_interval
//		ret = talk_interval_val;
//	}else{
		if(stack_datatype[sp] == TYPE_NUM){				// l
			ret = stack[sp];
		}else if(stack_datatype[sp] == TYPE_INT){		// ϐ(int)
			ret = script_symbols.get_symbol_val(stack[sp]);
		}
//	}
	
	return(ret);
}

//---------------------------------------------------------------------------
//		sX^bNւ̕ϐEl̊i[
//---------------------------------------------------------------------------
int nasino_script_setstackval(int sp,int num,int val_type)
{
	int ret;
	
	stack[sp] = num;
	stack_datatype[sp] = val_type;
	
//	sprintf(LogTmp,"nasino_script_setstackval:%d:%d\n",num,stack[sp]);
//	script_logwrite(LogTmp);
	
	return(ret);
}

//---------------------------------------------------------------------------
//		String̊i[
//
//	nasino_script.lQ
//---------------------------------------------------------------------------
int string_pool(char* word)
{
	int ret;
	
	printf("%s\n",word);
	ret = script_symbols.push_string(word);
//	ret = strobj.push_string(word);

	return(ret);
}

//---------------------------------------------------------------------------
//		symbol̓o^E
//		
//		char* symbol	IN		
//		int ret			OUT		o^ԍ
//
//		nasino_script.lQ
//---------------------------------------------------------------------------
int symbol_look(char* symbol)
{
	int num;
	
	printf("symbol_look : %s\n",symbol);
	
//	if(strcmp(symbol,"talk_interval") == 0){
//		num = TALK_INTERVAL;
//	}else{
		num = script_symbols.make(symbol);
//	}
	
	return(num);
}

//---------------------------------------------------------------------------
//		label쐬
//---------------------------------------------------------------------------
int nasino_script_genlabel()
{
	int ret;

	if(label_count >= LBLSIZE){
		//error! label_table overflow.
	}
	
	label_table[label_count] = code_count;
	printf("genlabel:%d:%d\n",label_count,code_count);
	ret = label_count;
	label_count++;

	return(ret);
}

//---------------------------------------------------------------------------
//		label
//---------------------------------------------------------------------------
int nasino_script_labelcomp(void)
{
	int count1;
	
	for(count1=0;count1<code_count;count1++){
		if (code_memory[count1].opecode == OP_LBL){
			code_memory[label_table[code_memory[count1].subcode]].subcode = count1;
//			printf("labelcomp:%d:%d\n",code_memory[count1].subcode,count1);
		}
	}

	return(OK);
}

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
void nasino_script_dumpcode()
{
//	int i;
	int count1;

	printf("code_count:%d\n",code_count);
	printf("%4s  %-10s %-10s %s\n\n","LINE","OP_CODE", "SUB_CODE","REF_LINE");
	sprintf(LogTmp,"%4s  %-10s %-10s %s\n\n","LINE","OP_CODE", "SUB_CODE","REF_LINE");
	script_logwrite(LogTmp);
	for(count1=0;count1<code_count;count1++){
//	for (i = 0; i < code_count; ++i){
//		printf("code_memory.opecode:%d\n",code_memory[code_count].opecode);
		sprintf(LogTmp,"\t%d\t",code_memory[count1].opecode);
		script_logwrite(LogTmp);
		switch(code_memory[count1].opecode){
		
		
			case OP_JP:
				printf("%4d  %-10s %10s %d\n",count1,"OP_JP","",code_memory[count1].subcode);
				sprintf(LogTmp,"%4d  %-10s %10s %d\n",count1,"OP_JP","",code_memory[count1].subcode);
				break;
			case OP_JPZ:
				printf("%4d  %-10s %10s %d\n",count1,"OP_JPZ","",code_memory[count1].subcode);
				sprintf(LogTmp,"%4d  %-10s %10s %d\n",count1,"OP_JPZ","",code_memory[count1].subcode);
				break;
				
			case OP_PSHI:
				printf("%4d  %-10s %s %d\n",count1,"OP_PSHI",get_symbol_name(code_memory[count1].subcode),code_memory[count1].subcode);		//
				sprintf(LogTmp,"%4d  %-10s %s %d\n",count1,"OP_PSHI",get_symbol_name(code_memory[count1].subcode),code_memory[count1].subcode);		//
				break;
			case OP_PSHP:
				printf("%4d  %-10s %s %d\n",count1,"OP_PSHP",script_symbols.pop_string(code_memory[count1].subcode),code_memory[count1].subcode);		//
//				printf("%4d  %-10s %s %d\n",count1,"OP_PSHP",strobj.pop_string(code_memory[count1].subcode),code_memory[count1].subcode);		//
				sprintf(LogTmp,"%4d  %-10s %s %d\n",count1,"OP_PSHP",script_symbols.pop_string(code_memory[count1].subcode),code_memory[count1].subcode);		//
//				sprintf(LogTmp,"%4d  %-10s %s %d\n",count1,"OP_PSHP",strobj.pop_string(code_memory[count1].subcode),code_memory[count1].subcode);		//
				break;
			case OP_ADD:
				printf("%4d  %-10s\n",count1, "OP_ADD");
				sprintf(LogTmp,"%4d  %-10s\n",count1, "OP_ADD");
				break;
			case OP_SUB:
				printf("%4d  %-10s\n",count1, "OP_SUB");
				sprintf(LogTmp,"%4d  %-10s\n",count1, "OP_SUB");
				break;
			case OP_MUL:
				printf("%4d  %-10s\n",count1, "OP_MUL");
				sprintf(LogTmp,"%4d  %-10s\n",count1, "OP_MUL");
				break;
			case OP_DIV:
				printf("%4d  %-10s\n",count1, "OP_DIV");
				sprintf(LogTmp,"%4d  %-10s\n",count1, "OP_DIV");
				break;
			case OP_MIN:
				printf("%4d  %-10s\n",count1, "OP_MIN");
				sprintf(LogTmp,"%4d  %-10s\n",count1, "OP_MIN");
				break;
			case OP_EQ:
				printf("%4d  %-10s\n",count1, "OP_EQ");
				sprintf(LogTmp,"%4d  %-10s\n",count1, "OP_EQ");
				break;
			case OP_NEQ:
				printf("%4d  %-10s\n",count1, "OP_NEQ");
				sprintf(LogTmp,"%4d  %-10s\n",count1, "OP_NEQ");
				break;
			case OP_GT:
				printf("%4d  %-10s\n",count1, "OP_GT");
				sprintf(LogTmp,"%4d  %-10s\n",count1, "OP_GT");
				break;
			case OP_GE:
				printf("%4d  %-10s\n",count1, "OP_GE");
				sprintf(LogTmp,"%4d  %-10s\n",count1, "OP_GE");
				break;
			case OP_LS:
				printf("%4d  %-10s\n",count1, "OP_LS");
				sprintf(LogTmp,"%4d  %-10s\n",count1, "OP_LS");
				break;
			case OP_LE:
				printf("%4d  %-10s\n",count1, "OP_LE");
				sprintf(LogTmp,"%4d  %-10s\n",count1, "OP_LE");
				break;
			case OP_AND:
				printf("%4d  %-10s\n",count1, "OP_AND");
				sprintf(LogTmp,"%4d  %-10s\n",count1, "OP_AND");
				break;
			case OP_OR:
				printf("%4d  %-10s\n",count1, "OP_OR");
				sprintf(LogTmp,"%4d  %-10s\n",count1, "OP_OR");
				break;
			case OP_STRCPY:
				printf("%4d  %-10s\n",count1, "OP_STRCPY");
				sprintf(LogTmp,"%4d  %-10s\n",count1, "OP_STRCPY");
				break;
			case OP_STRCAT:
				printf("%4d  %-10s\n",count1, "OP_STRCAT");
				sprintf(LogTmp,"%4d  %-10s\n",count1, "OP_STRCAT");
				break;
			case OP_STRCMP:
				printf("%4d  %-10s\n",count1, "OP_STRCMP");
				sprintf(LogTmp,"%4d  %-10s\n",count1, "OP_STRCMP");
				break;
			case OP_ATOI:
				printf("%4d  %-10s\n",count1, "OP_ATOI");
				sprintf(LogTmp,"%4d  %-10s\n",count1, "OP_ATOI");
				break;
			case OP_ITOA:
				printf("%4d  %-10s\n",count1, "OP_ITOA");
				sprintf(LogTmp,"%4d  %-10s\n",count1, "OP_ITOA");
				break;
			case OP_RAND:
				printf("%4d  %-10s\n",count1, "OP_RAND");
				sprintf(LogTmp,"%4d  %-10s\n",count1, "OP_RAND");
				break;
			case OP_DATE:
				printf("%4d  %-10s\n",count1, "OP_DATE");
				sprintf(LogTmp,"%4d  %-10s\n",count1, "OP_DATE");
				break;
			case OP_SSTPSEND:
				printf("%4d  %-10s\n",count1, "OP_SSTPSEND");
				sprintf(LogTmp,"%4d  %-10s\n",count1, "OP_SSTPSEND");
				break;
			case OP_SAVE:
				printf("%4d  %-10s\n",count1, "OP_SAVE");
				sprintf(LogTmp,"%4d  %-10s\n",count1, "OP_SAVE");
				break;
			case OP_LOAD:
				printf("%4d  %-10s\n",count1, "OP_LOAD");
				sprintf(LogTmp,"%4d  %-10s\n",count1, "OP_LOAD");
				break;
			case OP_GET_INITFILEDATA:
				printf("%4d  %-10s\n",count1, "OP_GET_INITFILEDATA");
				sprintf(LogTmp,"%4d  %-10s\n",count1, "OP_GET_INITFILEDATA");
				break;
		
			case OP_POP:
				printf("%4d  %-10s %s\n",count1,"OP_POP",get_symbol_name(code_memory[count1].subcode));		//
				sprintf(LogTmp,"%4d  %-10s %s\n",count1,"OP_POP",get_symbol_name(code_memory[count1].subcode));		//
				break;
			case OP_PSHN:
				printf("%4d  %-10s %d\n",count1,"OP_PSHN",code_memory[count1].subcode);
				sprintf(LogTmp,"%4d  %-10s %d\n",count1,"OP_PSHN",code_memory[count1].subcode);
				break;
			case OP_LBL:
				printf("%4d  %-10s %d\n",count1,"OP_LBL",code_memory[count1].subcode);
				sprintf(LogTmp,"%4d  %-10s %d\n",count1,"OP_LBL",code_memory[count1].subcode);
				break;
		}
		script_logwrite(LogTmp);
	}
}


//---------------------------------------------------------------------------
//		ϐ̏o
//---------------------------------------------------------------------------
void script_datadump(void)
{
	int count1;
	char word[64];
	int symboltype;
	
	if(Script_Log == OFF){
		return;
	}

	printf("script_datadump\n");
	script_logwrite("script_datadump\n");
	
	printf("SAKURA EVENT\n");
	script_logwrite("SAKURA EVENT\n");
	for(count1=S22EVENT_EVENT;count1<=S22EVENT_REFERENCE7;count1++){
		if(count1 == S22EVENT_EVENT){
			strcpy(LogTmp,"Event");
		}else{
			sprintf(LogTmp,"Reference%d",count1-S22EVENT_REFERENCE0);
		}
		sprintf(word,":%s:\n",sakura_event.get_str(count1));
		strcat(LogTmp,word);
		script_logwrite(LogTmp);
		printf("%s",LogTmp);
	}
	script_logwrite("\n");
	printf("\n");
	
	printf("User EVENT\n");
	script_logwrite("User EVENT\n");
	for(count1=S22EVENT_EVENT;count1<=S22EVENT_REFERENCE7;count1++){
		if(count1 == S22EVENT_EVENT){
			strcpy(LogTmp,"UserEvent");
		}else{
			sprintf(LogTmp,"UserReference%d",count1-S22EVENT_REFERENCE0);
		}
		sprintf(word,":%s:\n",user_event.get_str(count1));
		strcat(LogTmp,word);
		script_logwrite(LogTmp);
		printf("%s",LogTmp);
	}
	script_logwrite("\n");
	printf("\n");
	
	printf("SYSTEM Val\n");
	script_logwrite("SYSTEM Val\n");
	strcpy(LogTmp,"talk_interval");
	sprintf(word,":%d:\n",talk_interval_val);
	strcat(LogTmp,word);
	script_logwrite(LogTmp);
	printf("%s",LogTmp);
	script_logwrite("\n");
	printf("\n");
	

//	printf("%d\n",script_symbols.read_num());
	
	
	for(count1=Reserve_Num;count1<(Reserve_Num+script_symbols.read_num());count1++){
		symboltype = script_symbols.get_symbol_type(count1);
		printf("ϐ %s ",script_symbols.get_symbol_name(count1));
		sprintf(LogTmp,"ϐ %s ",script_symbols.get_symbol_name(count1));
		script_logwrite(LogTmp);
		if(symboltype == TYPE_INT){
			printf("INT^ %d\n",script_symbols.get_symbol_val(count1));
			sprintf(LogTmp,"INT^ %d\n",script_symbols.get_symbol_val(count1));
		}else if(symboltype == TYPE_CHAR){
			printf("CHAR^ %s\n",script_symbols.get_symbol_str(count1));
			sprintf(LogTmp,"CHAR^ %s\n",script_symbols.get_symbol_str(count1));
		}else if(symboltype == TYPE_INTDIM){
			printf("INT^z %d\n",script_symbols.get_symbol_val(count1));
			sprintf(LogTmp,"INT^z %d\n",script_symbols.get_symbol_val(count1));
		}else if(symboltype == TYPE_CHARDIM){
			printf("CHAR^z %s\n",script_symbols.get_symbol_str(count1));
			sprintf(LogTmp,"CHAR^z %s\n",script_symbols.get_symbol_str(count1));
		}else if(symboltype == TYPE_STR){
			printf("\n");
			sprintf(LogTmp,"\n");
		}else{
			printf("^s\n");
			sprintf(LogTmp,"^s\n");
		}
		script_logwrite(LogTmp);
	}
	
//	for(count1=(Reserve_Num + Code_Num);count1<(Reserve_Num + Code_Num)+strobj.read_num();count1++){
//		printf("strobj%d:%s\n",count1,strobj.pop_string(count1));
//	}
	
	return;
}

//---------------------------------------------------------------------------
//		LOGo
//---------------------------------------------------------------------------
int script_logwrite(char* logword)
{
	FILE *fp_log;
	char filename[DataLength];
	
	if(Script_Log == ON){
		sprintf(filename,"%s%s",DataPath,SCRIPTLOG_FILENAME);
//		printf("ini filename : %s\n",filename);

		if((fp_log = fopen(filename,"at"))==NULL){
			/* nasino.ini don't open!! */
			printf("testlogfile don't open!!\n");
			return(FALSE);
		}else{
			fputs(logword,fp_log);
			fclose(fp_log);
		}
	}

	return(0);
}

